Attribute VB_Name = "Module1"
Option Explicit

Public WebSites(0 To 41, 0 To 1) As String
Public EnableMousePicboxCursor As Boolean

Const SW_SHOW = 5

Private Const BIF_STATUSTEXT = &H4&
Private Const BIF_RETURNONLYFSDIRS = 1
Private Const BIF_DONTGOBELOWDOMAIN = 2
Private Const MAX_PATH = 260

Private Const WM_USER = &H400
Private Const BFFM_INITIALIZED = 1
Private Const BFFM_SELCHANGED = 2
Private Const BFFM_SETSTATUSTEXT = (WM_USER + 100)
Private Const BFFM_SETSELECTION = (WM_USER + 102)

Public Const PI = 3.14159265358979

Public Type PointType
    X As Double
    Y As Double
End Type

Public ParabolaPoints As Single
Public P(1 To 3) As PointType
Public GraphPoints() As Double

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Private Type BrowseInfo
  hWndOwner      As Long
  pIDLRoot       As Long
  pszDisplayName As Long
  lpszTitle      As Long
  ulFlags        As Long
  lpfnCallback   As Long
  lParam         As Long
  iImage         As Long
End Type

Public Reg As RegressionObject
Private m_CurrentDirectory As String
Public InitDir As String

Public Function BrowseForFolder(owner As Form, Title As String, StartDir As String) As String
    'Handle "browser for folder dialog
    'Opens a Treeview control that displays the directories in a computer
    Dim lpIDList As Long, szTitle As String, sBuffer As String
    Dim tBrowseInfo As BrowseInfo
    m_CurrentDirectory = StartDir & vbNullChar
    szTitle = Title
    With tBrowseInfo
        .hWndOwner = owner.hwnd
        .lpszTitle = lstrcat(szTitle, "")
        .ulFlags = BIF_RETURNONLYFSDIRS + BIF_DONTGOBELOWDOMAIN + BIF_STATUSTEXT
        .lpfnCallback = GetAddressofFunction(AddressOf BrowseCallbackProc)  'get address of function.
    End With
    lpIDList = SHBrowseForFolder(tBrowseInfo)
    If (lpIDList) Then
        sBuffer = Space(MAX_PATH)
        SHGetPathFromIDList lpIDList, sBuffer
        sBuffer = Left(sBuffer, InStr(sBuffer, vbNullChar) - 1)
        BrowseForFolder = sBuffer
    Else
        BrowseForFolder = ""
    End If
End Function

Private Function BrowseCallbackProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal lp As Long, ByVal pData As Long) As Long
    Dim lpIDList As Long, ret As Long, sBuffer As String
    On Error Resume Next  'MS Sugested: prevent error from propagating back into calling process.
    Select Case uMsg
        Case BFFM_INITIALIZED
            Call SendMessage(hwnd, BFFM_SETSELECTION, 1, m_CurrentDirectory)
        Case BFFM_SELCHANGED
            sBuffer = Space(MAX_PATH)
            ret = SHGetPathFromIDList(lp, sBuffer)
            If ret = 1 Then Call SendMessage(hwnd, BFFM_SETSTATUSTEXT, 0, sBuffer)
    End Select
    BrowseCallbackProc = 0
End Function

Private Function GetAddressofFunction(add As Long) As Long
    ' This function allows you to assign a function pointer to a variable.
    GetAddressofFunction = add
End Function

Public Sub errhandler(location As String, errnumber As String, errdescription As String)
    MsgBox "There was an Error" & vbCrLf & vbCrLf & _
           "The Error was: Error Number " & errnumber & " : " & errdescription, vbOKOnly, "Error"
End Sub

Public Sub Navigate(ByVal NavTo As String)
    On Error GoTo NavigateErr
    Dim hBrowse As Long
    hBrowse = ShellExecute(0&, "open", NavTo, "", "", SW_SHOW)
    Exit Sub
    '
NavigateErr:
    errhandler "Navigate", Err.Number, Err.Description
End Sub

Public Sub LoadWebSites()
    On Error GoTo LoadWebSitesErr
    Dim n As Long
    'load websites into array
    '------------------------------------------------------------------------------
    'theory sites
    WebSites(0, 0) = "Parabola History and Examples"
    WebSites(1, 0) = "Parabola Math"
    WebSites(2, 0) = "Parabola Animation"
    WebSites(3, 0) = "Parabola Focal Point Math"
    WebSites(4, 0) = "Parabola Focal Point Animation"
    WebSites(5, 0) = "Parabola Math and Examples"
    WebSites(6, 0) = "Parabola History and Math"
    WebSites(37, 0) = "Purple Parabola Place"
    WebSites(38, 0) = "Parabolas"
    WebSites(39, 0) = "Parabolas in Life"
    WebSites(40, 0) = "Parabola Application"
    WebSites(41, 0) = "Why Are Satellite Dishes Parabolic?"
    '------------------------------------------------------------------------------
    WebSites(0, 1) = "http://acre.murdoch.edu.au/refiles/hightemp/"
    WebSites(1, 1) = "http://www-gap.dcs.st-and.ac.uk/~history/Curves/Parabola.html"
    WebSites(2, 1) = "http://www-gap.dcs.st-and.ac.uk/~history/Java/Parabola.html"
    WebSites(3, 1) = "http://mathworld.wolfram.com/Parabola.html"
    WebSites(4, 1) = "http://www.ies.co.jp/math/java/conics/focus/focus.html"
    WebSites(5, 1) = "http://www.xahlee.org/SpecialPlaneCurves_dir/Parabola_dir/parabola.html"
    WebSites(6, 1) = "http://www.2dcurves.com/conicsection/conicsectionp.html"
    WebSites(37, 1) = "http://mtl.math.uiuc.edu/users/M1Sallee/lesson.html"
    WebSites(38, 1) = "http://home.alltel.net/okrebs/page64.html"
    WebSites(39, 1) = "http://edservices.aea7.k12.ia.us/edtech/teacherpages/jmbrown/"
    WebSites(40, 1) = "http://www.np.edu.sg/mscIntMaths/PlnAnalGeom/4_Para.htm"
    WebSites(41, 1) = "http://mathcentral.uregina.ca/RR/database/RR.09.95/weston1.html"
    '==============================================================================
    'application web sites
    WebSites(7, 1) = "http://scitoys.com/scitoys/scitoys/light/solar_hotdog_cooker.html"
    WebSites(8, 1) = "http://www.cockeyed.com/incredible/parabola/parabola2.html"
    WebSites(9, 1) = "http://solarcooking.org/unattendedparabolic.htm"
    WebSites(10, 1) = "http://www.bali-i.com/solar/parabolic-prod.htm"
    WebSites(11, 1) = "http://www.acs.comcen.com.au/parabolic.html"
    WebSites(12, 1) = "http://home.arcor.de/Ernst.Willand/amsi-model.html"
    WebSites(13, 1) = "http://www.nrel.gov/education/pdfs/d_vinson.pdf"
    WebSites(14, 1) = "http://www.mueller-solartechnik.de/koch_eng.htm"
    WebSites(15, 1) = "http://home.arcor.de/Ernst.Willand/amsi-idea.html"
    WebSites(16, 1) = "http://solarcooking.org/parabolic-from-flat-sheet.htm"
    WebSites(17, 1) = "http://www.angelfire.com/ak/egel/kidheater.html"
    WebSites(18, 1) = "http://home.arcor.de/Ernst.Willand/amsi-conf.html"
    WebSites(19, 1) = "http://solarcooking.org/reflective-cooker-robustness.htm"
    WebSites(20, 1) = "http://solarcooking.org/plans.htm#parabolic-style"
    WebSites(21, 1) = "http://ashokk_3.tripod.com/solar1.htm"
    WebSites(22, 1) = "http://www.angelfire.com/80s/shobhapardeshi/ParvatiCooker.html"
    WebSites(23, 1) = "http://www.cc.jyu.fi/~hvirtane/cooker/"
    WebSites(24, 1) = "http://journeytoforever.org/sc_link.html"
    WebSites(25, 1) = "http://solarcooking.org/links.htm"
    WebSites(26, 1) = "http://www.mueller-solartechnik.com"
    '------------------------------------------------------------------------
    'review these sites
    WebSites(27, 1) = "http://www.grc.nasa.gov/WWW/K-12/Numbers/Math/Mathematical_Thinking/sun12.htm"
    WebSites(28, 1) = "http://ublib.buffalo.edu/libraries/e-resources/ebooks/records/751-1.html"
    WebSites(29, 1) = "http://icp.giss.nasa.gov/research/urbanmaap/aerosols_train6.html"
    WebSites(30, 1) = "http://www.zoo.ufl.edu/gpryor/biosphere.3.html"
    WebSites(31, 1) = "http://www.altenergy.org/2/renewables/solar/solar.html"
    WebSites(32, 1) = "http://almashriq.hiof.no/lebanon/600/610/614/solar-water/unesco/21-23.html"
    WebSites(33, 1) = "http://almashriq.hiof.no/lebanon/600/610/614/solar-water/unesco/24-26.html"
    WebSites(34, 1) = "http://rredc.nrel.gov/solar/"
    WebSites(35, 1) = "http://rredc.nrel.gov/solar/old_data/nsrdb/redbook/atlas/"
    WebSites(36, 1) = "http://www.ecoworld.org/Home/articles2.cfm?TID=288"
    '------------------------------------------------------------------------
    WebSites(7, 0) = "Cook hotdogs with the Sun in minutes."
    WebSites(8, 0) = "Home Parabola project using mirrors"
    WebSites(9, 0) = "A Parabolic Solar Cooker for Unattended Cooking"
    WebSites(10, 0) = "The Everest Parabolic Cooker"
    WebSites(11, 0) = "Parabolic Solar Collector Design Instructions"
    WebSites(12, 0) = "Parabola Design - Wood Model"
    WebSites(13, 0) = "Parabolic Troughs - Solar Hot Water Heaters"
    WebSites(14, 0) = "Examples of Available Solar Cooker Products"
    WebSites(15, 0) = "The Idea of Solar Cooking"
    WebSites(16, 0) = "Making a Parabolic Reflector Out of a Flat Sheet"
    WebSites(17, 0) = "Making a Parabolic Reflector from Trash"
    WebSites(18, 0) = "The Ninth International Conference on Solar Cooking"
    WebSites(19, 0) = "Reflective Solar Cooker Technical Discussion"
    WebSites(20, 0) = "Parabolic Cookers"
    WebSites(21, 0) = "Review of Solar Cooker Designs"
    WebSites(22, 0) = "How to make and use Parvati Solar Cooker "
    WebSites(23, 0) = "Designing and Building Home Made Focusing Solar Cookers"
    WebSites(24, 0) = "Solar Cooker Resources"
    WebSites(25, 0) = "Lots More Solar Links"
    WebSites(26, 0) = "Commercial Site Solar Cookers and Water Purification"
    '------------------------------------------------------------------------
    WebSites(27, 0) = "Calculating the Energy from Sunlight"
    WebSites(28, 0) = "Earth's Energy Balance"
    WebSites(29, 0) = "How Sunphotometers Determine Optical Depth"
    WebSites(30, 0) = "Biosphere Activated: Solar Power"
    WebSites(31, 0) = "Alternative Energy Institute, Inc."
    WebSites(32, 0) = "Solar Energy - From Sun to Earth"
    WebSites(33, 0) = "Solar Energy - World Distribution"
    WebSites(34, 0) = "Solar Radiation Resource Information"
    WebSites(35, 0) = "U.S. Solar Radiation Resource Maps"
    WebSites(36, 0) = "EcoWorld - Solar PV & Thermal Concentrators "
    '------------------------------------------------------------------------
    'load websites into labels
    For n = 0 To 41
        frmInput.lblParabolaSites(n).Caption = WebSites(n, 0)
        frmInput.lblParabolaSites(n).Font.Underline = True
        frmInput.lblParabolaSites(n).MousePointer = 99
    Next n
    'make html page of these links
    'MakeHTMLPage
   Exit Sub
   '
LoadWebSitesErr:
   errhandler "Sub LoadWebSites", Err.Number, Err.Description
   End Sub
   
Public Sub LoadURL(URL)
    On Error Resume Next
    Dim modobjie As Object
    Set modobjie = CreateObject("InternetExplorer.Application")
    modobjie.Visible = True
    modobjie.Navigate2 URL
    'modlngWndIE = modobjie.hwnd
    Set modobjie = Nothing
End Sub

Public Function CheckTextBoxEntries(ByVal keyascii)
    If IsNumeric(frmInput.txtDiameter.Text) And _
       IsNumeric(frmInput.txtDepth.Text) And _
       keyascii = 13 Then
            frmInput.btnCalculate.Value = True
    End If
End Function

Private Sub MakeHTMLPage()
    Dim n As Long, filenum As Long, filename As String
    filename = "c:\temp\links.htm"
    filenum = FreeFile
    Open filename For Output As #filenum
        Print #filenum, "<html>" & vbCrLf & "<head>" & vbCrLf & "<title>Solar Links</title>" & vbCrLf & "</head>" & vbCrLf & vbCrLf & "<body>" & vbCrLf
        Print #filenum, "<h4 align=""" & "center" & """>Solar Links</h4>" & vbCrLf
        For n = LBound(WebSites, 1) To UBound(WebSites, 1)
            '<a href="http://www.google.com">Site Text</a>
            Print #filenum, "<a href=""" & WebSites(n, 1) & """>" & WebSites(n, 0) & "</a>" & vbCrLf
            Print #filenum, "<br><br>" & vbCrLf
        Next n
        Print #filenum, "</html>" & vbCrLf & "</body>"
    Close #filenum
End Sub

Public Function LinearDiameter(ByVal num As Single) As Double
    Dim i As Double, j As Long, n As Long, LinearDistance As Double, LinearDistanceTotal As Double
    Dim x1 As Double, x2 As Double, y1 As Double, y2 As Double, X As Double
    LinearDistance = 0
    LinearDistanceTotal = 0
    If num > 0 Then num = num * -1
    'if x = 0 lineardiameter = 0
    'special case, avoid precision error
    If num = 0 Then GoTo done
    For n = LBound(GraphPoints, 2) To UBound(GraphPoints, 2)
        'find current X point in array
        X = GraphPoints(1, n)
        If X = num Then
            'calculate distance from this x point to x = 0 point
            For j = n + 1 To UBound(GraphPoints, 2) \ 2 + 1
                x1 = GraphPoints(1, j - 1)
                x2 = GraphPoints(1, j)
                y1 = GraphPoints(2, j - 1)
                y2 = GraphPoints(2, j)
                LinearDistance = Sqr((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
                LinearDistanceTotal = LinearDistanceTotal + LinearDistance
            Next j
            GoTo done
        End If
    Next n
done:
    LinearDiameter = LinearDistanceTotal
End Function
