Attribute VB_Name = "Module4"
Option Explicit

  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  ' Copyright 1996-2003 VBnet, Randy Birch, All Rights Reserved.
  ' Some pages may also contain other copyrights by the author.
  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  ' Distribution: You can freely use this code in your own
  '               applications, but you may not reproduce
  '               or publish this code on any web site,
  '               online service, or distribute as source
  '               on any media without express permission.
  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  
'Visual Basic Internet Routines
                  
'Starting Specified URLs in Separate Instances of the  Default Browser
'http://www.mvps.org/vbnet/index.html?code/internet/browserstart.htm
'Posted:  Monday October 18, 1999
'Updated: Monday August 05, 2002
'Applies to: VB4 -32, VB5, VB6
'Developed with: VB6, Windows NT4
'OS restrictions: None
'Author: VBnet - Randy Birch
'Prerequisites None.
'  While ShellExecute will reliably display a specified URL in the default browser, whether or not the call to
'  ShellExecute will reuse an existing browser session or open a new session is always unknown to the
'  developer. The code presented here uses the FindExecutable method detailed in Obtaining the Path and
'  Filename of the Default Browser, and the CreateProcess API to force a new instance of the browser to
'  be created for every call to the start routine.

  Public Const CREATE_NEW_CONSOLE As Long = &H10
  Public Const NORMAL_PRIORITY_CLASS As Long = &H20
  Public Const INFINITE As Long = -1
  Public Const STARTF_USESHOWWINDOW As Long = &H1
  Public Const SW_SHOWNORMAL As Long = 1

  Public Const MAX_PATH As Long = 260
  Public Const ERROR_FILE_NO_ASSOCIATION As Long = 31
  Public Const ERROR_FILE_NOT_FOUND As Long = 2
  Public Const ERROR_PATH_NOT_FOUND As Long = 3
  Public Const ERROR_FILE_SUCCESS As Long = 32 'my constant
  Public Const ERROR_BAD_FORMAT As Long = 11

  Public Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
  End Type

  Public Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadID As Long
  End Type

  Public Declare Function CreateProcess Lib "kernel32" _
     Alias "CreateProcessA" _
    (ByVal lpAppName As String, _
     ByVal lpCommandLine As String, _
     ByVal lpProcessAttributes As Long, _
     ByVal lpThreadAttributes As Long, _
     ByVal bInheritHandles As Long, _
     ByVal dwCreationFlags As Long, _
     ByVal lpEnvironment As Long, _
     ByVal lpCurrentDirectory As Long, _
     lpStartupInfo As STARTUPINFO, _
     lpProcessInformation As PROCESS_INFORMATION) As Long
       
  Public Declare Function CloseHandle Lib "kernel32" _
    (ByVal hObject As Long) As Long

  Public Declare Function FindExecutable Lib "shell32" _
     Alias "FindExecutableA" _
    (ByVal lpFile As String, _
     ByVal lpDirectory As String, _
     ByVal sResult As String) As Long

  Public Declare Function GetTempPath Lib "kernel32" _
     Alias "GetTempPathA" _
    (ByVal nSize As Long, _
     ByVal lpBuffer As String) As Long

Public Function StartNewBrowser(sURL As String) As Boolean
    'start a new instance of the user's browser
    'at the page passed as sURL
     Dim success As Long
     Dim hProcess As Long
     Dim sBrowser As String
     Dim start As STARTUPINFO
     Dim proc As PROCESS_INFORMATION
     sBrowser = GetBrowserName(success)
    'did sBrowser get correctly filled?
     If success >= ERROR_FILE_SUCCESS Then
       'prepare STARTUPINFO members
        With start
           .cb = Len(start)
           .dwFlags = STARTF_USESHOWWINDOW
           .wShowWindow = SW_SHOWNORMAL
        End With
       'start a new instance of the default
       'browser at the specified URL. The
       'lpCommandLine member (second parameter)
       'requires a leading space or the call
       'will fail to open the specified page.
        success = CreateProcess(sBrowser, _
                                " " & sURL, _
                                0&, 0&, 0&, _
                                NORMAL_PRIORITY_CLASS, _
                                0&, 0&, start, proc)
       'if the process handle is valid, return success
        StartNewBrowser = proc.hProcess <> 0
       'don't need the process
       'handle anymore, so close it
        Call CloseHandle(proc.hProcess)
       'and close the handle to the thread created
        Call CloseHandle(proc.hThread)
     End If
  End Function

  Public Function GetBrowserName(dwFlagReturned As Long) As String
    'find the full path and name of the user's
    'associated browser
     Dim hFile As Long
     Dim sResult As String
     Dim sTempFolder As String
    'get the user's temp folder
     sTempFolder = GetTempDir()
    'create a dummy html file in the temp dir
     hFile = FreeFile
        Open sTempFolder & "dummy.html" For Output As #hFile
     Close #hFile
    'get the file path & name associated with the file
     sResult = Space$(MAX_PATH)
     dwFlagReturned = FindExecutable("dummy.html", sTempFolder, sResult)
    'clean up
     Kill sTempFolder & "dummy.html"
    'return result
     GetBrowserName = TrimNull(sResult)
  End Function

  Public Function TrimNull(item As String)
    'remove string before the terminating null(s)
     Dim pos As Integer
     pos = InStr(item, Chr$(0))
     If pos Then
           TrimNull = Left$(item, pos - 1)
     Else: TrimNull = item
     End If
  End Function

  Public Function GetTempDir() As String
    'retrieve the user's system temp folder
     Dim tmp As String
     tmp = Space$(256)
     Call GetTempPath(Len(tmp), tmp)
     GetTempDir = TrimNull(tmp)
  End Function

